%define srcversion 2.2.15
%define kversion 2.2.15
%define release 2mdk
%define mosixver 0.97.4

Summary: The Linux kernel with the MOSIX patch (process migration).
Name: kernel-mosix
Version: %{kversion}
Release: %{release}
%define KVERREL %{kversion}-%{release}
Copyright: GPL
Group: System/Kernel and hardware
URL: http://www.mosix.cs.huji.ac.il/
ExclusiveArch: i386 i486 i586 i686 k6 k7
ExclusiveOS: Linux
Requires: mosix-utils
Obsoletes: kernel-modules, kernel-sparc
Source0: ftp://ftp.kernel.org/pub/linux/kernel/v2.2/linux-%{srcversion}.tar.bz2
Source19: linux_logo.h.bz2
Source20: kernel-mosix-%{version}-i586.config
Source21: rhkmvtag.c
# MOSIX
Source100: http://www.mosix.cs.huji.ac.il/ftps/MOSIX-%{mosixver}.tar.bz2
Source101: mosix.map

#MOSIX
Patch400: mosix.patch.bz2
Patch401: mosix-paths.patch.bz2
BuildRoot: /%{_tmppath}/%{name}-buildroot
BuildRequires: egcs

%description
The kernel package contains the Linux kernel (vmlinuz), the core of your
Linux Mandrake operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

This version of kernel is a version with the MOSIX patch to allow process
migration in a cluster of MOSIX nodes.

%package -n mosix-utils
Summary: The utilities to manage MOSIX clusters
Group: System/Kernel and hardware
Version: %{mosixver}

%description -n mosix-utils
MOSIX utils

%prep
%setup -q -n linux

mv include/linux/linux_logo.h include/linux/linux_logo.h.logomdk
bzcat %{SOURCE19} > include/linux/linux_logo.h
cp $RPM_SOURCE_DIR/rhkmvtag.c .

bzcat %{SOURCE100}|tar xvf -
tar xvf kernel.new.%{kversion}.tar
patch -p0 < patches.%{kversion}
tar xvf manuals.tar
tar xvf user.tar
bzcat $RPM_SOURCE_DIR/mosix-paths.patch.bz2 | patch -p0 -b -z .fred

make clean -C scripts/ksymoops/

find . -name "*.orig"|xargs rm -f
find . -name "*~"|xargs rm -f

%define dir lib/moslib bin/mosrun sbin/{setpe,tune,versionate} usr.bin/{migrate,mon,mosctl}

%build
rm -rf $RPM_BUILD_ROOT

if [ -x /usr/bin/getconf ] ; then
    NRPROC=$(/usr/bin/getconf _NPROCESSORS_ONLN)
    if [ $NRPROC -eq 0 ] ; then
	NRPROC=1
    fi
else
    NRPROC=1
fi

Config=%{_target_cpu}
KernelVer=%{KVERREL}

cp $RPM_SOURCE_DIR/kernel-mosix-%{kversion}-$Config.config arch/%{_arch}/defconfig
rm -f .config
perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}mosix/" Makefile

# compile mosix utils
top=`pwd`
for d in %{dir}; do
    cd $top/$d
    make
done
cd $top

mv ./sbin/tune/testloop.s ./sbin/tune/testloop.s.saved
make mrproper
mv ./sbin/tune/testloop.s.saved ./sbin/tune/testloop.s
make oldconfig

cmp -s .config $RPM_SOURCE_DIR/kernel-mosix-%{kversion}-$Config.config || \
 cp -vf .config $RPM_SOURCE_DIR/kernel-mosix-%{kversion}-$Config.config

make dep
make include/linux/version.h
%ifarch i386 i486 i586 i686 k6 k7
make -j $NRPROC bzImage
%else
make -j $NRPROC boot
%endif
make -j $NRPROC modules
find include/linux/modules -size 0 | while read file ; do echo > $file;  done


%install
rm -rf $RPM_BUILD_ROOT

KernelVer=%{KVERREL}

# MOSIX
mkdir -p $RPM_BUILD_ROOT/usr/{bin,lib,include,man/man1}  $RPM_BUILD_ROOT/{bin,sbin} $RPM_BUILD_ROOT/etc/rc.d/init.d

top=`pwd`
for d in %{dir}; do
    cd $top/$d
    make install
done

cd $top
mkdir -p $RPM_BUILD_ROOT/usr/man/man7
install -m 644 man7/mosix.7 $RPM_BUILD_ROOT/usr/man/man7

mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 mosix.init $RPM_BUILD_ROOT/etc/rc.d/init.d/mosix
install -m 644 %{SOURCE101} $RPM_BUILD_ROOT/etc/

# kernel
mkdir -p $RPM_BUILD_ROOT/boot

install -m 644 System.map $RPM_BUILD_ROOT/boot/System.map-${KernelVer}mosix
%ifarch i386 i486 i586 i686 k6 k7
cp arch/i386/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-${KernelVer}mosix
%else
# Only copy the raw version
cp vmlinux $RPM_BUILD_ROOT/boot/vmlinux-${KernelVer}mosix
%endif
mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer/{block,cdrom,fs,ipv4,misc,net,scsi,video}
make INSTALL_MOD_PATH=$RPM_BUILD_ROOT modules_install KERNELRELEASE=${KernelVer}mosix
%ifnarch sparc64
cc -o rhkmvtag rhkmvtag.c init/version.o
./rhkmvtag > $RPM_BUILD_ROOT/lib/modules/$KernelVer/.rhkmvtag
rm -f rhkmvtag
%endif

$RPM_BUILD_ROOT/sbin/versionate ${KernelVer}mosix -d$RPM_BUILD_ROOT/lib/modules/${KernelVer}mosix/misc

%clean
rm -rf $RPM_BUILD_ROOT

%pre
/sbin/modprobe loop 2> /dev/null > /dev/null
rm -f /lib/modules/%{KVERREL}mosix/modules.dep
exit 0

%post -n mosix-utils
ldconfig
/sbin/chkconfig --add mosix

%postun -n mosix-utils

if [ "$1" = 0 ]; then
ldconfig
/sbin/chkconfig --del mosix
fi

%files
%defattr(-,root,root)
%ifarch i386 i486 i586 i686 k6 k7
/boot/vmlinuz-%{KVERREL}mosix
%else
/boot/vmlinux-%{KVERREL}mosix
%endif
/boot/System.map-%{KVERREL}mosix
/lib/modules/%{KVERREL}mosix

%files -n mosix-utils
%defattr(-,root,root)
/usr/bin/*
/usr/include/*
/bin/*
/sbin/*
/usr/lib/*
/usr/man/*/*
%config /etc/rc.d/init.d/mosix
%config(noreplace) /etc/mosix.map

%changelog
* Fri May  5 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.2.15-2mdk
- new MOSIX 0.97.4 !

* Fri May  5 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.2.15-1mdk
- MOSIX 0.97.4
- kernel 2.2.15

* Thu Apr 27 2000 Frederic Lepied <flepied@jedi.mandrakesoft.com> 2.2.14-2mdk
- MOSIX 0.97.3

* Wed Apr 12 2000 Frederic Lepied <flepied@jedi.mandrakesoft.com> 2.2.14-1mdk
- first release based on kernel-linus.



